; *********************************************************
; *                   Projekt W006S001                    *
; *          Firmware fr Geocaching-Magnetbake           *
; *                                                       *
; *********************************************************
; *                                                       *
; *    (c) 2009 Jochen Wienstroth                         *
; *    wienstroth unkonventionelle technik zeitgem      *
; *    Am Deutschherrenberg 33                            *
; *    D-35578 Wetzlar                                    *
; *    Tel 06441-445061 / Fax 03222-1168698               *
; *    http://www.chrysophylax.de                         *
; *                                                       *
; *                                        08.02.2010     *
; *                                                       *
; *********************************************************
; *                                                       *
; *     Der Quellcode der eingebundenen Datei             *
; *     P16F690.INC ist Freeware von Arizona Microchip.   *
; *                                                       *
; *********************************************************
; *                                                       *
; *     Die Nutzung dieser Software ist nur innerhalb     *
; * 	des Rahmens gestattet, den die Lizenzbe-          *
; *     dingungen                     .                   *
; *                                                       *
; *             Creative Commons - BY-NC-SA               *
; *  http://creativecommons.org/licenses/by-nc-sa/3.0/de/ *
; *                                                       *
; *     vorgeben.                                         *
; *                                                       *
; *     Jede Abweichung der Nutzung dieser Software       *
; *     von den genannten Bestimmungen darf nur           *
; *     mit schriftlicher Genehmigung durch den oben      *
; *     genannten Urheberrechtsinhaber erfolgen !         *
; *                                                       *
; *********************************************************

FVer		= h'0001'		;Firmware-Version

;                             Firmware-Historie:
;                             ==================

;	V0.01 (08.02.10 *JWie*)
;  Erste Version, die Magnetbake und Reaktivlicht-Funktionalitt
;  in einundderselben Software enthlt.



HVer		= h'0001'		;Hardware-Version der Platine: W006L001V001

;                             Hardware-Historie:
;                             ==================
;	V0.01 (16.09.09 *JWie*)
;	Pin-Belegung fr PIC16F690 handgefdelt nach W006L001V001 auf Lochraster

	title "Firmware fr Geocaching Magnetbake"
	subtitle "Hardwaredefinitionen"

	#define __16F690		; Auswahl des Prozessor-Typs

	;#define DEBUG			; Debug-Ausgabe 
					; in diesem Projekt (noch) nicht genutzt

	list p=16f690, n=73, c=120
	INCLUDE "P16F690.INC"		; Definition chipspezifischer Register 16F690

USER_RAM	= h'20'			; Beginn des User-RAMs

	radix	dec
	errorlevel -306, -303,-302
						 ; 306: crossing page boundary
						 ; 303: Programm word too large - truncated
						 ; 302: Register not in Bank0

;   Chipkonfiguration
; *********************

	__idlocs FVer       ;Firmware-Version steht in ID-Locations, da eventuell lesegeschtztes Flash

	__config _INTOSCIO & _PWRTE_ON & _CP_ON & _CPD_OFF & _BOR_NSLEEP & _WDT_OFF & _MCLRE_ON & _FCMEN_OFF & _IESO_OFF
; 		 Interner Oszillator, Power-Up-Timer on,  Code-protect on, Data-Protect off,
; 		 Brownout on (auer Sleep), Watchdog aus, Master-Clear an, klein Clock-Switching int<->ext

; I/O-Belegung fr 16F690
;*************************

; Port A
; Label  PIN	  	I/O          Funktion
RA0  	 = 0    ;     RA0/ULPWO: O RA0 ULPWU RC-Glied
RA1  	 = 1    ;     RA1        I RA1 Eingang: EEPROM-Text neu programmierung (PullUp)
RA2  	 = 2    ;     RA2        O RA2 Ausgang: LDR-Versorgung fr Helligkeitsmessung
RA3  	 = 3    ;     RA3:       I RA3 System: #MCLR
RA4  	 = 4    ;     RA4:       O RA4 Ausgang: unbenutzt
RA5  	 = 5    ;     RA5:       O RA5 Ausgang: unbenutzt

SYS_TRISA= b'00001010' ; RA1, RA3 Eingnge, alle anderen Ausgnge
SYS_WPUA = b'00001010' ; Weak Pullup RA1, RA3
SYS_IOCA = b'00000001' ; RA0 darf einen Interrupt auslsen (Wake Up from Ultra Low Power Sleep)

; Port B
; Label  PIN	  	I/O          Funktion
RB4  	 = 4    ;   AN10:    A   AN10 Meeingang Helligkeitswert
RB5      = 5    ;   RXD:     I   RXD  Empfangene Daten von TTL-RS232
RB6      = 6    ;   RB6:     I   RB6  Pullup fr RS232-Eingang
RB7      = 7    ;   RB7:     O   RB7  Unbenutzt

SYS_TRISB= b'01110000' ;  RB4..6 Eingnge, RB7 Ausgang (RB5 wird UART)
SYS_WPUB = b'00000000' ;  keine Pullups
SYS_IOCB = b'00000000' ;  kein Pin darf Interrupts auslsen

; Port C
; Alles Ausgnge fr die Siebensackzementanzeige
SEGa  	 = h'01'    ;   oben quer          -------
SEGb  	 = h'02'    ;   oben rechts       |   a   |
SEGc  	 = h'04'    ;   unten rechts      |f     b|
SEGd  	 = h'08'    ;   unten quer        |       |
SEGe  	 = h'10'    ;   unten links        -------
SEGf  	 = h'20'    ;   oben links        |   g   |
SEGg  	 = h'40'    ;   mitte quer        |e     c|
SEGDP  	 = h'80'    ;   Dezimalpunkt      |       |
;                                          -------  O DP
SYS_TRISC = b'00000000' ; Alle 8 Ausgnge     d

; AD-Wandler
SYS_ANSEL       = b'00000000' ; AN0..7 deaktiviert
SYS_ANSELH      = b'00000100' ; AN10 = Eingang fr Helligkeitsmessung, Rest deaktiviert
SYS_ADCON0	= b'00101001' ; Kanal 10, Vref=Vdd, AD-Modul einschalten
SYS_ADCON1	= b'01110000' ; AD-Wandler aus eigenem Oszillator betreiben

; Prozessorgeschwindigkeit
; Der PIC startet defaultmig mit internem Takt, dieser wird anaschlieend auf 31kHz konfiguriert

SYS_OSCCON = b'00000001' ; 31kHz aus internem LF-Oszillator
SYS_OPTION = b'00000111' ; TMR bekommt Prescaler:256, zhlt fOsc/4

	subtitle "Definition interner Speicher"
	page


;   GPR-Adressen (Int. RAM):
; ****************************
	cblock	USER_RAM; Globale Variablen (RAM fngt unabhngig von der
			; Bank immer an der gleichen Adresse an)
	ANAVAL		; aktueller Analogwert aus letzter Wandlung

; Speicher fr Mittelwertbildung Helligkeitswerte	
	HVAL:16		; Array letzte 16 Messwerte
	HCTR		; Zeiger im Array fr Mittelwertbildung
	HMSUM:2		; Summenzhler fr Mittelwertbildung Helligkeitswerte
	HMED		; mittlerer Dunkelwert

	G_FLAGS		; Globale Flags	

	DCTR		; Anzahl Wandlungen zwischen zwei in die Mittelwertbildung einbezogenen
			; Wandlungen im Dunkel-Modus

; Registerbank "Main" / Liegt in RAM Page 0
	endc

; Wird fr Interrupt bentigt ("Common RAM" in allen Bnken vorhanden)
; RAM-Bereich in allen Banks identisch fr Interrupt-Zwischenspeicher
	cblock  h'72' 
	R0		; Arbeitsregister 0 bis 5, Hilfs-Akkus XX-ZZ
	R1		; Diese Register drfen nur im Hauptprogramm und
	R2		; NICHT im INT benutzt werden, da sie beim
	R3		; Eintreffen eines Interrupts nicht gerettet
	R4		; werden !!
	R5		
	XX
	YY
	ZZ		
	RL_CONF		; Reaktivlicht-Globales Configbyte

	IR0		; Interrupt-Arbeitsregister0 - nur da verwenden !
	IWTEMP	        ; Zwischenspeicher fr W-Register im Interrupt
	ISTEMP          ; Zwischenspeicher fr Status-Register im Interrupt
	ILTEMP         	; Zwischenspeicher fr PCLATH im Interrupt
	endc

;   Bit-Adressen:
; *****************


; Parameter fr alles mgliche...
	subtitle "Programmspeicher: Systemvektoren, Interrupteinsprnge, Sprungtabelle"
	page
; #====================================================================================#
; #====================================================================================#
; #       Globaler Reset-Vektor                                                        #
; #                                                                                    #
; #====================================================================================#
; #====================================================================================#

	org     0x0000		; Reset-Vektor

	NOP			; Hier ICE-Einsprung wenn gewnscht
	NOP			; Hier ICE-Einsprung wenn gewnscht
	GOTO    INITX		; Weiter mit Initialisierung

	org	0x0004		; Globaler Interrupt-Einsprung
	RETFIE			; unbenutzt, nur sicherheitshalber da.

; #====================================================================================#
; #       NIB27SEG                                                                     #
; #       bersetzt das unterste Nibble von W in einen 7Segment-anzeigbaren Wert       #
; #       Liegt so weit unten im Programmspeicher, um vor berlufen von PC beim       #
; #       addieren sicher zu sein. Nicht hochgradig schn, aber sehr zweckmig!       #
; #====================================================================================#
NIB27SEG
	ANDLW	0x0f		; nur das untere Nibble ist interessant
	ADDWF	PCL,f		; Nibble auf PC addieren, Rcksprung aus Tabelle:
	RETLW	0xc0 		; "0"
	RETLW	0xf9 		; "1"
	RETLW	0xa4 		; "2"
	RETLW	0xb0 		; "3"
	RETLW	0x99 		; "4"
	RETLW	0x92 		; "5"
	RETLW	0x82 		; "6"
	RETLW	0xf8 		; "7"
	RETLW	0x80 		; "8"
	RETLW	0x90 		; "9"
	RETLW	0x88		; "A"
	RETLW	0x83		; "b"
	RETLW	0xa7		; "c"
	RETLW	0xa1		; "d"
	RETLW	0x86 		; "E"
	RETLW	0x8E		; "F"


    subtitle "Programmspeicher: Hauptprogramm"
; #====================================================================================#
; #====================================================================================#
; #       Initialisierung des Chips auf Betriebswerte                                  #
; #                                                                                    #
; #====================================================================================#
; #====================================================================================#

INITX
	BSF	STATUS,RP0	;In Bank1 schalten
	MOVLW	SYS_OSCCON	;Prozessor-Geschwindigkeit
	MOVWF	OSCCON		;setzen
	MOVLW	SYS_OPTION	;Options-Register default laden
	MOVWF	OPTION_REG	;setzen
	BCF 	STATUS,RP0	;Zurck in Bank0 schalten

	MOVLW	0x01	
	MOVWF 	PORTA		;Port A Ausgnge lschen bis auf RA0 (ULPW)
	CLRF	PORTB		;Port B Ausgnge lschen
	MOVLW	h'ff'
	MOVWF	PORTC		;Port C Ausgnge lschen

	BSF	STATUS,RP0 	;Config-Register in Bank1 schreiben
	MOVLW	SYS_TRISA	;Digital-Inputs A nach Vordefinition
	MOVWF	TRISA
	MOVLW	SYS_WPUA	;Pullups Inputs nach Vordefinition
	MOVWF	WPUA
	MOVLW	SYS_IOCA	;Interrupt-Fhigkeiten nach Vordefinition
	MOVWF	IOCA
	MOVLW	SYS_TRISB	;Digital-Inputs B nach Vordefinition
	MOVWF	TRISB
	MOVLW	SYS_TRISC	;Digital-Inputs C nach Vordefinition
	MOVWF	TRISC
	MOVLW	SYS_ADCON1	;AD-Wandler Takt konfigurieren
	MOVWF	ADCON1		;in Steuerregister schreiben
	BCF 	STATUS,RP0 	;zurck in Bank0 schalten

	BSF	STATUS,RP1	;in Bank2 schalten
	MOVLW	SYS_WPUB	;Pullups Inputs nach Vordefinition
	MOVWF	WPUB		
	MOVLW	SYS_IOCB	;Interrupt-Fhigkeiten nach Vordefinition
	MOVWF	IOCB
	MOVLW	SYS_ANSELH
	MOVWF	ANSELH		;Analog-Funktionen auf oberen Kanlen
	MOVLW	SYS_ANSEL
	MOVWF	ANSEL		;Analog-Funktion auf unteren Kanlen
	BCF	STATUS,RP1	;zurck in Bank0 schalten

	MOVLW	HVAL		;Zeiger Helligkeitswertindex initialisieren
	MOVWF	HCTR		;und abspeichern. (Zeigt auf ersten Eintrag)

; #====================================================================================#
; #====================================================================================#
; #       Hauptprogramm: Abarbeiten Reaktivlicht/Magnetbake......                      #
; #                                                                                    #
; #====================================================================================#
; #====================================================================================#
MAIN
	MOVLW	LOW(EEGLOB)	;EEPROM-Adrezeiger auf Konfigurationsbyte
	CALL	RD_EEDATW	;Konfig-Byte lesen
	MOVWF	RL_CONF		;in globaler Variable abspeichern

	MOVLW	LOW(EEDCTR)	;EEPROM-Adrezeiger auf Dunkelberspringungszhler
	CALL	RD_EEDATW	;Konfig-Byte lesen
	MOVWF	DCTR		;in Dunkelberspringungszhler speichern

	BTFSC	RL_CONF,0	;0=Magnetbake, dann berspringen.
	GOTO	R_LICHT		;bei Reaktivlicht weiterarbeiten

; #====================================================================================#
; #                             Funktionalitt Magnetbake                              #
; #====================================================================================#
MBAKE
	CALL 	KOOR		;Koordinaten ausgeben
	GOTO	$		;warten bis Sankt Nimmerlein
				;(Brownout schlgt irgendwann zu und
				; beendet das Warten sauber)

; #====================================================================================#
; #                            Funktionalitt Reaktivlicht                             #
; #====================================================================================#
R_LICHT
	CALL	AVREAD		;Analogwert lesen

	BTFSS	G_FLAGS,0	;GFLAGS[0]=1, dann Tagmodus
	GOTO	R_NACHT		;GFLAGS[0]=0 => Nachtmodus

; #====================================================================================#
; #                                     Tagmodus                                       #
; #====================================================================================#
R_TAG
	BTFSS	RL_CONF,1	;RL_CONF[1]=1 => Alive-Blink im Tag-Modus
	GOTO	R_TAG1		;Alive-Blink berspringen

	BCF	PORTC,7		;DP an
	MOVLW	1		;10ms
	CALL	PAUSE		;Pause abwarten
	BSF	PORTC,7		;DP aus

R_TAG1
	CALL	MITMATH		;Mittelwertmathematik anschubsen

	MOVLW	LOW(EEDLEV)	;Schwellwert fr Umschaltung Nachtmodus
	CALL	RD_EEDATW	;holen

	SUBWF	HMED,W		;C=1 wenn Schwelle < Mittelwert
	BTFSS	STATUS,C	;berspringen, wenn Schwelle < Mittelwert = bleibt im Tagmodus
	GOTO	R_TAGN		;Reaktivlicht in Nachtmodus setzen
	
	CALL	ULSLEEP		;bleibe im Tagmodus, also einschlafen
	GOTO	R_LICHT		;nach Aufwachen nchsten Analogwert lesen

R_TAGN
	BCF	G_FLAGS,0	;Flag auf "Nachtmodus" (=0)
	MOVLW	LOW(EETACTR)	;Tagzhler
	CALL	RD_EEDATW	;holen
	ADDLW	1		;+1
	MOVWF	R1		;in R1 abspeichern
	DECF	R0,f		;Adrezhler wieder runterzhlen
	CALL	WR_EEDAT	;R1 in EEPROM Adr. R0 schreiben
	MOVF	R1,f		;Gabs einen berlauf (=0) ?
	BTFSS	STATUS,Z	;Ja => berspringen
	GOTO	R_LICHT		;kein berlauf -> im Nachtmodus weiter

	CALL	RD_EEDAT	;Hi-Byte Tagzhler holen
	ADDLW	1		;+1
	MOVWF	R1		;in R1 abspeichern
	DECF	R0,f		;Adrezhler wieder runterzhlen
	CALL	WR_EEDAT	;R1 in EEPROM Adr. R0 schreiben
	GOTO	R_LICHT

; #====================================================================================#
; #                                     Nachtmodus                                     #
; #====================================================================================#
R_NACHT	
	DECFSZ	DCTR,f		;Dunkelberspringungszhler runterzhlen, bei 0 berspr.
	GOTO	R_NACHT1	;ungleich 0, also keine Mittelwertbildung

	CALL	MITMATH		;0, also Mittelwertmathematik anschubsen
	MOVLW	LOW(EEDCTR)	;EEPROM-Adrezeiger auf Dunkelberspringungszhler
	CALL	RD_EEDATW	;Konfig-Byte lesen
	MOVWF	DCTR		;in Dunkelberspringungszhler speichern

R_NACHT1
	; Abtesten, ob der Mittelwert grer ist als die Hell-Schaltschwelle
	MOVLW	LOW(EEHLEV)	;EEPROM-Adrezeiger auf Schwelle Hell-Modus
	CALL	RD_EEDATW	;Konfig-Byte lesen
	SUBWF	HMED,W		;W = Mittelwert - Schwellwert; C=1 wenn Schwellwert<Mittelwert
	BTFSS	STATUS,C	;berspringen, wenn Schwell<Mittel (Nacht->Tag - Wechsel)
	GOTO	$+3		;bleiben im Nachtmodus

	;jawoll ! Wechsel zum Tagmodus
	BSF	G_FLAGS,0	;Flag fr Tagmodus setzen
	GOTO	R_LICHT		;im Tagmodus weitermachen
	
	; Abtesten, ob aktueller Wert noch dunkler ist als der Mittelwert
	MOVF	HMED,W		;Mittelwert in w holen
	SUBWF	ANAVAL,W	;W = Analog-Mittelwert; C=1 wenn Mittelwert<=Analog (="heller")
	BTFSS	STATUS,C	;berspringen, wenn An>Mi
	GOTO	R_NACHTS	;nachtschlafen legen, weil "noch dunkler"

	; Analogwert ist grer als Mittelwert, also testen, ob "Sprung"
				;w enthlt die Sprunghhe ("Analog - Mittel")
	MOVWF	R3		;Sprunghhe zwischenspeichern
	MOVLW	LOW(EETRIG)	;EEPROM-Adrezeiger auf Triggersprungwert
	CALL	RD_EEDATW	;Konfig-Byte lesen
	SUBWF	R3,w		;W = Sprung-Trigger - SC=1 wenn Sprunghhe <= Triggerwert
	BTFSS	STATUS,C	;berspringen, wenn Sprung > Triggerwert
	GOTO	R_NACHTS	;nachtschlafen legen

	CALL	KOOR		;Koordinatentext ausgeben

	BTFSS	RL_CONF,2	;Testmodus aktiviert ? Ja => berspringen
	GOTO	R_NACHTS	;Nein, gleich weiter schlafen

	MOVLW	HVAL		; Zeiger Mittelwerttabellen-Start
	MOVWF	FSR		; In Indirekt-Register schreiben
	MOVLW	16		; 16 Durchgnge
	MOVWF	XX		; in Schleifenregister
	MOVF	ANAVAL,w	; Analogwert holen
	MOVWF	HMED		; in Mittelwertergebnis schreiben

	MOVWF	INDF		; in Mittelwerttabelle schreiben
	INCF	FSR,f		; Zeiger erhhen
	DECFSZ	XX,f		; Schleife runterzhlen
	GOTO	$-3		; noch Durchgnge ber
	
R_NACHTS 
				;Nachtschlafen legen
	BSF	STATUS,RP0	;In Bank 1 schalten
	MOVLW	b'00001111'	;WDT Prescaler auf :4096, WDT ON (=130ms Timemout)
	MOVWF	WDTCON		;Watchdog aktivieren
	CLRWDT			;WDT rcksetzen
	MOVLW	b'00010000'	;Vorladen fr WDT aus
	SLEEP			;einschlafen bis WD-Timeout
	; hier schlafen wir, bis der Watchdog abluft
	MOVWF	WDTCON		;Watchdog ausschalten
	BCF	STATUS,RP0	;zurck in Bank0

	GOTO	R_LICHT		;Von vorne anfangen

; #====================================================================================#
; #       Hauptprogramm: Ende                                                          #
; #                                                                                    #
; #====================================================================================#
	subtitle "Programmspeicher: Unterprogramme"
	page

; #====================================================================================#
; #====================================================================================#
; #       Unterprogramme                                                               #
; #                                                                                    #
; #====================================================================================#
; #====================================================================================#

;   Analog-Wert einlesen
; ========================

; INPUT:	-, Prozessor mu in Bank0 sein
; MODIFIED:	W, Flags
; OUTPUT:	ANAVAL & W enthalten gelesenen Wert

AVREAD
	BSF	PORTA,2		; LDR Versorgung einschalten
	MOVLW	SYS_ADCON0	; Kanal whlen, AD-Modul einschalten
	MOVWF	ADCON0		; in Steuerregister schreiben
	NOP			; Warten, bis MUX garantiert sitzt
	BSF	ADCON0,GO	; AD-Wandlung anschubsen
	BTFSC	ADCON0,GO	; Wandlung abwarten
	GOTO	$-1
	MOVF	ADRESH,w	; Ergebnis holen
	MOVWF	ANAVAL		; Ergebnis speichern	
	BCF	ADCON0,ADON	; AD-Wandler ausschalten
	BCF	PORTA,2		; LDR-Versorgung ausschalten
	RETURN		

	
;   Ultra-Low-Power-Sleep
; =========================

; INPUT:	-
; MODIFIED:	W, Flags
; OUTPUT:	Bank 0 gesetzt
	
ULSLEEP
	MOVF	PORTA,w		; Dummy-Read Port A, um IOC-Int lschen zu knnen
	BCF	INTCON,RABIF	; Interrupt-Flag lschen
	BSF	STATUS,RP0	; in Bank 1 schalten
	BSF	PCON,ULPWUE	; ULPWU Enable
	BSF	TRISA,RA0	; RA0 auf Eingang setzen
	BSF	INTCON,RABIE	; Interrupt-Enable, um Aufwachen zu ermglichen
	BCF	STATUS,RP0	; zurck in Bank 0
	SLEEP			; schlafen bis Kondensator leer
	MOVF	PORTA,w		; Dummy-Read Port A, um IOC-Int lschen zu knnen
	BCF	INTCON,RABIF	; Interrupt-Flag lschen
	BSF	STATUS,RP0	; in Bank 1 schalten
	BCF	PCON,ULPWUE	; ULPWU Disable
	BCF	TRISA,RA0	; RA0 auf Ausgang setzen
	BCF	INTCON,RABIE	; Interrupt-Disable fr Portchange-Interrupts
	BCF	STATUS,RP0	; zurck in Bank 0
	BSF	PORTA,RA0	; Kondensator neu laden
	RETURN

;   EEPROM-Byte lesen
; =====================

; INPUT:	R0 enthlt Adresse
; MODIFIED:	R0, STATUS, W
; OUTPUT:	W enthlt Datenbyte, R0 wird weitergezhlt, Bank 0 gesetzt
RD_EEDATW
	MOVWF	R0		; W enthlt Adresse
RD_EEDAT
	BCF	STATUS,RP0	; Bank 2
	BSF	STATUS,RP1
	MOVF	R0,W		; Adresse
	MOVWF	EEADR		; setzen
	CLRF	EEADRH		; High-Byte EEPROM-Adresse lschen
	BSF	STATUS,RP0	; Bank 3
	BCF	EECON1,EEPGD	; EEPROM lesen, nicht Flash
	BSF	EECON1,RD	; Lesen starten
	BCF	STATUS,RP0	; Bank 2
	MOVF	EEDATA,W	; Byte holen
	BCF	STATUS,RP1	; Bank 0
	INCF	R0,F		; Pointer inc.
	RETURN

;   EEPROM-Byte schreiben
; =====================

; INPUT:	R0 enthlt Adresse, R1 enthlt zu schreibenden Wert
; MODIFIED:	R0, STATUS, W
; OUTPUT:	W enthlt Datenbyte, R0 wird weitergezhlt, Bank 0 gesetzt
WR_EEDATW
	MOVWF	R0		; W enthlt Adresse
WR_EEDAT
	BCF	STATUS,RP0	; Bank 2
	BSF	STATUS,RP1
	MOVF	R0,W		; Adresse
	MOVWF	EEADR		; setzen
	CLRF	EEADRH		; High-Byte EEPROMadresse lschen
	MOVF	R1,W		; Wert
	MOVWF	EEDAT		; ins Wert-Register schreiben
	BSF	STATUS,RP0	; Bank 3
	BCF	EECON1,EEPGD	; EEPROM schreiben, nicht Flash
	BSF	EECON1,WREN	; Schreibsequenz starten
	MOVLW	0x55		; Marker 1
	MOVWF	EECON2		; in Steuerregister
	MOVLW	0xAA		; Marker 2
	MOVWF	EECON2		; in Steuerregister
	BSF	EECON1,WR	; anschubsen
	
	BTFSC	EECON1,WR	; wenn fertig berspringen
	GOTO	$-1		; noch nicht fertig

	BCF	STATUS,RP0	; Bank 2
	BCF	STATUS,RP1	; Bank 0
	INCF	R0,F		; Pointer inc.
	RETURN

;    PAUSE (n * 10ms warten)
;  ===========================
; INPUT:	W
; MODIFIED:	STATUS, W, XX
; OUTPUT:	Bank 0 gesetzt,

PAUSE
	MOVWF	XX		; Pausenzeit in XX abspeichern
	BSF	STATUS,RP0	; Bank1
	BCF	STATUS,RP1	
	MOVLW	b'00000000'	; Timer0 an fOsc/4, Prescaler:2
	MOVWF	OPTION_REG      ; fOsc = 31kHz !
	BCF	STATUS,RP0	; Bank0
P_SCHL
	MOVLW	(255-37)	; Timer mit 37 vorladen (38,5 wren 10ms)
	MOVWF	TMR0            ; "Rest fr die Gottlosen nach Augenma"
	BCF	INTCON, T0IF	; berlauf-Bit lschen
	BTFSS	INTCON, T0IF	; berspringen, wenn gesetzt
	GOTO	$-1		; warten, bis gesetzt
	DECFSZ	XX,f		; Schleifenzhler runter, berspringen wenn fertig
	GOTO	P_SCHL		; weiter warten
	
	RETURN

;    KOOR (Koordinaten-Zeichenkette aus EEPROM ausgeben
;  =====================================================
; INPUT:	-
; MODIFIED:	STATUS, W, XX, YY, ZZ, R0 , R1 (XX in Sub PAUSE)
; OUTPUT:	Bank 0 gesetzt
KOOR
	MOVLW	LOW(EEKOORD)	; EEPROM-Adrezeiger auf Adr. 0x01
	MOVWF	R0		; 
	CALL	RD_EEDAT	; Anzahl Zeichen im EEPROM holen
	MOVWF	R1		; in R1 abspeichern
	CALL	RD_EEDAT	; Leuchtzeit (n * 10ms) aus EEPROM holen
	MOVWF	YY		; in YY abspeichern
	CALL	RD_EEDAT	; Pausenzeit (n * 10ms) aus EEPROM holen
	MOVWF	ZZ		; in ZZ abspeichern

K_SCHL
	CALL	RD_EEDAT	; Auszugebendes Zeichen aus dem EEPROM holen
	MOVWF	PORTC		; Auf Siebensackzement-Anzeige ausgeben
	MOVF	YY,W		; Leuchtzeit
	CALL	PAUSE		; Warten
	MOVLW	h'ff'		; Port C
	MOVWF	PORTC		; aus
	MOVF	ZZ,W		; Dunkelzeit
	CALL	PAUSE		; warten
	DECFSZ	R1,f		; Schleifenzhler runterzhlen
	GOTO	K_SCHL		

	MOVLW	LOW(EETRCTR)	;Triggerzhler
	CALL	RD_EEDATW	;holen
	ADDLW	1		;+1
	MOVWF	R1		;in R1 abspeichern
	DECF	R0,f		;Adrezhler wieder runterzhlen
	CALL	WR_EEDAT	;R1 in EEPROM Adr. R0 schreiben
	MOVF	R1,f		;Gabs einen berlauf (=0) ?
	BTFSS	STATUS,Z	;Ja => berspringen
	GOTO	$+6		;fertig

	CALL	RD_EEDAT	;Hi-Byte Triggerzhler holen
	ADDLW	1		;+1
	MOVWF	R1		;in R1 abspeichern
	DECF	R0,f		;Adrezhler wieder runterzhlen
	CALL	WR_EEDAT	;R1 in EEPROM Adr. R0 schreiben

	BSF	STATUS,RP1	;in Bank 2 schalten
	BSF	WPUB,RB6	;Pullup fr RB6 einschalten
	BTFSC	PORTB,RB5	;berspringen, wenn Debug-Brcke gesetzt
	GOTO	KOOR_END

	BCF	WPUB,RB6	;Pullup fr RB6 wieder ausschalten
	BCF	STATUS,RP1	;in Bank0 zurck
	MOVLW	0xf7		;"_"
	CALL	WOUT		;ausgeben

	MOVLW	LOW(EETRCTR)	;Triggerzhler
	CALL	HEXOUT16	;Hexwert ausgeben

	BTFSS	RL_CONF,0	;berspringen bei Reaktivlicht
	GOTO	KOOR_END	;zurck

				;Reaktivlicht, also noch Tagezhler und Sprunghhe ausgeben
	MOVLW	0xbf		;"-"
	CALL	WOUT		;ausgeben

	MOVLW	LOW(EETACTR)	;Tagezhler
	CALL	HEXOUT16	;Hexwert ausgeben


	MOVLW	0xfe		;"^" ("Strich oben")
	CALL	WOUT		;ausgeben
	MOVF	R3,w		;Sprunghhe holen	
	CALL	HEXOUT		;Ausgeben

				;fertig mit Ausgabe

KOOR_END
	BCF	WPUB,RB6	;Pullup fr RB6 wieder ausschalten
	BCF	STATUS,RP1	;sicher zurck in Bank0 schalten
	RETURN

;    HEXOUT (Gibt Wert in W als Hexzahl aus)
;  =====================================================
; INPUT:	W: Auszugebener Hex-Wert
; MODIFIED:	STATUS, W, XX, YY, ZZ, R0, R1 (XX in Sub PAUSE)
; OUTPUT:	Bank 0 gesetzt
HEXOUT
	MOVWF	R1		; W in R1 zwischenspeichern
	MOVLW	LOW(EEKOORD+1)	; EEPROM-Adrezeiger auf Adr. 0x01
	CALL	RD_EEDATW	; Leuchtzeit (n * 10ms) aus EEPROM holen
	MOVWF	YY		; in YY abspeichern
	CALL	RD_EEDAT	; Pausenzeit (n * 10ms) aus EEPROM holen
	MOVWF	ZZ		; in ZZ abspeichern

	SWAPF	R1,w		;High Nibble nach W
	CALL	NIB27SEG	;wandeln in 7Seg
	MOVWF	PORTC		;ausgeben
	MOVF	YY,w		;Leuchtzeit abwarten		
	CALL	PAUSE
	MOVLW	0xff			
	MOVWF	PORTC		;7Seg aus
	MOVF	ZZ,w		;Pausenzeit abwarten
	CALL	PAUSE

	MOVF	R1,w		;Low Nibble nach W
	CALL	NIB27SEG	;wandeln in 7Seg
	MOVWF	PORTC		;ausgeben
	MOVF	YY,w		;Leuchtzeit abwarten		
	CALL	PAUSE
	MOVLW	0xff		
	MOVWF	PORTC		;7Seg aus
	MOVF	ZZ,w		;Pausenzeit abwarten
	CALL	PAUSE

	RETURN

;    HEXOUT16 (Gibt EEPROM-Wert Offset W als 16Bit-Hexzahl aus)
;  ==============================================================
; INPUT:	W: Offset Hi-Byte Auszugebener Hex-Wert im EEPROM
; MODIFIED:	STATUS, W, XX, YY, ZZ, R0, R1, R2 (XX in Sub PAUSE)
; OUTPUT:	Bank 0 gesetzt
HEXOUT16
	CALL	RD_EEDATW	; Lo-Byte lesen
	MOVWF	R1		; Lo in R1 zwischenspeichern
	CALL	RD_EEDAT	; Hi-Byte lesen
	MOVWF	R2		; Hi in R2 zwischenspeichern
	MOVLW	LOW(EEKOORD+1)	; EEPROM-Adrezeiger auf Adr. 0x01
	CALL	RD_EEDATW	; Leuchtzeit (n * 10ms) aus EEPROM holen
	MOVWF	YY		; in YY abspeichern
	CALL	RD_EEDAT	; Pausenzeit (n * 10ms) aus EEPROM holen
	MOVWF	ZZ		; in ZZ abspeichern

	SWAPF	R2,w		;High Nibble nach W
	CALL	NIB27SEG	;wandeln in 7Seg
	MOVWF	PORTC		;ausgeben
	MOVF	YY,w		;Leuchtzeit abwarten		
	CALL	PAUSE
	MOVLW	0xff			
	MOVWF	PORTC		;7Seg aus
	MOVF	ZZ,w		;Pausenzeit abwarten
	CALL	PAUSE

	MOVF	R2,w		;Low Nibble nach W
	CALL	NIB27SEG	;wandeln in 7Seg
	MOVWF	PORTC		;ausgeben
	MOVF	YY,w		;Leuchtzeit abwarten		
	CALL	PAUSE
	MOVLW	0xff		
	MOVWF	PORTC		;7Seg aus
	MOVF	ZZ,w		;Pausenzeit abwarten
	CALL	PAUSE

	SWAPF	R1,w		;High Nibble nach W
	CALL	NIB27SEG	;wandeln in 7Seg
	MOVWF	PORTC		;ausgeben
	MOVF	YY,w		;Leuchtzeit abwarten		
	CALL	PAUSE
	MOVLW	0xff			
	MOVWF	PORTC		;7Seg aus
	MOVF	ZZ,w		;Pausenzeit abwarten
	CALL	PAUSE

	MOVF	R1,w		;Low Nibble nach W
	CALL	NIB27SEG	;wandeln in 7Seg
	MOVWF	PORTC		;ausgeben
	MOVF	YY,w		;Leuchtzeit abwarten		
	CALL	PAUSE
	MOVLW	0xff		
	MOVWF	PORTC		;7Seg aus
	MOVF	ZZ,w		;Pausenzeit abwarten
	CALL	PAUSE

	RETURN

;    WOUT (Gibt Wert in W auf Anzeige aus)
;  =====================================================
; INPUT:	W: Auszugebener Hex-Wert
; MODIFIED:	STATUS, W, XX, R0 (XX in Sub PAUSE)
; OUTPUT:	Bank 0 gesetzt
WOUT
	MOVWF	PORTC
	MOVLW	LOW(EEKOORD+1)	; EEPROM-Adrezeiger auf Adr. 0x01
	CALL	RD_EEDATW	; Leuchtzeit (n * 10ms) aus EEPROM holen
	CALL	PAUSE		; abwarten
	MOVLW	0xff			
	MOVWF	PORTC		; 7Seg aus
	CALL	RD_EEDAT	; Pausenzeit (n * 10ms) aus EEPROM holen
	CALL	PAUSE		; abwarten
	RETURN


;    MITMATH (Mittelwert-Mathematik ber 16 Analogwerte)
;  =====================================================

; INPUT:	ANAVAL enthlt aktuellen Analogwert, der in die Serie einbezogen
;               werden soll.
; MODIFIED:	FSR, XX, W
; OUTPUT:	HMED enthlt aktualisierten Mittelwert ber 16 Messungen

MITMATH
	MOVF	HCTR,w		; Zeiger auf zu verndernde Mittelwert-Position holen
	MOVWF	FSR		; In Indirekt-Register schreiben
	MOVF	ANAVAL,w	; Analogwert holen
	MOVWF	INDF		; in Tabelle schreiben
	INCF	HCTR,f		; Zeiger erhhen
	
	MOVLW	(HVAL+16)	; berlauf ? (Mehr als 16 Werte)
	XORWF	HCTR,w		; Vergleichen
	BTFSS	STATUS,Z	; berspringen, wenn berlauf
	GOTO 	$+3		; kein berlauf, Tabelle nicht neu setzen
	MOVLW	HVAL		; Tabellenanfang
	MOVWF	HCTR		; setzen

	CLRF	HMSUM		; Summenzhler Lo lschen
	CLRF	(HMSUM+1)	; Summenzhler Hi lschen

	MOVLW	HVAL		; Anfang Tabelle laden
	MOVWF	FSR		; ins Indirekt-Register schreiben

	MOVLW	16		; 16 Schleifendurchgnge
	MOVWF	XX		; XX wird Zhlvariable

MITM_S
	MOVF	INDF,w		; Tabelleneintrag holen
	INCF	FSR,f		; Tebellenzeiger hochzhlen

	ADDWF	HMSUM,f		; Auf Summenzhler draufaddieren
	BTFSC	STATUS,C	; berspringen, wenn kein bertrag
	INCF	(HMSUM+1),f	; bertrag: Hi-Byte erhhen

	DECFSZ	XX,f		; Schleifenzhler runterzhlen
	GOTO	MITM_S		; noch Durchlufe abzuarbeiten

	SWAPF	(HMSUM+1),f	; 4 LSB werden 4 MSB
	MOVLW	0xf0		; neue 4 LSB
	ANDWF	(HMSUM+1),f	; ausmaskieren
	SWAPF	HMSUM,w		; 4 MSB werden 4 LSB in w
	ANDLW	0x0f		; 4 MSB in w ausblenden
	IORWF	(HMSUM+1),f	; 4 LSB aus W nach Hi-Zhler
				; Wilde Swapperei entspricht Division durch 16, ist schneller
				; als Schieben durchs Carry-Register
	MOVF	(HMSUM+1),w	; Hi-Zhler enthlt
	MOVWF	HMED		; Mittelwert
	
	RETURN

; #====================================================================================#
; #====================================================================================#
; #       Sonstiges: EE-Speicher                                                       #
; #                                                                                    #
; #====================================================================================#
; #====================================================================================#

	subtitle "Sonstiges: EE-Speicher"
	page

	org 0x2100
; Generelle Konfigurationsparameter
EEGLOB
	de b'00000000'
;            |||||||+- 1= Reaktivlicht, 0= Magnetbake
;            ||||||+-- 1= "Alive-Blink" im Tagmodus Reaktivlicht
;            |||||+--- 1= berbgeln Mittelwerte nach Koordinatenausgabe ("Testmodus")
;            ||||+----
;            |||+-----
;            ||+------
;            |+-------
;            +--------
EEDCTR
	de 10	; jede wievielte Messung wird im Dunkelmodus in die Mittelwertbildung 
		; einbezogen ?
EEDLEV
	de 32	; Schwelle, unter der in Nachtmodus ("Dunkel") gewechselt wird
EEHLEV
	de 48	; Schwelle, ber der in Tagmodus ("Hell") gewechselt wird
EETRIG
	de 4	; Helligkeitssprung nach oben fr Auslsung
EETRCTR
	de 0,0	; 16Bit-Zhler fr Anzahl Auslsungen
EETACTR
	de 0,0	; 16Bit-Zhler fr Anzahl Tage

; Parameter rund um die Zeichenausgabe
EEKOORD
	de LOW(EEENDE)-LOW(EEKOORD)-3	; Anzahl Zeichen
	de 80   ; Leuchtzeit * 10ms (die das Zeichen leuchtet)
	de 5	; Pausenzeit * 10ms (zwischen den Zeichen)

; eigentliche Zeichen, vorher Templates zur Verwendung mit Kopierpaste

; gngige Zeichen fr Anzeige:

;	de 0xc0		; "0"
;	de 0xf9		; "1"
;	de 0xa4		; "2"
;	de 0xb0		; "3"
;	de 0x99		; "4"
;	de 0x92		; "5"
;	de 0x82		; "6"
;	de 0xf8		; "7"
;	de 0x80		; "8"
;	de 0x90		; "9"
;	de 0x88		; "A"
;	de 0x83		; "b"
;	de 0xa7		; "c"
;	de 0xa1		; "d"
;	de 0x86		; "E"
;	de 0x8E		; "F"
;	de 0x82		; "G"
;	de 0x89 	; "H"
;	de 0xc7 	; "L"
;	de 0xab		; "n"
;	de 0xc8 	; "N"
;	de 0x87		; "t"
;	de 0xe3		; "u"
;	de 0xc1		;" U"


;	de 0xbf 	; "-"
;	de 0xff 	; " "
;       de 0x7f 	; "."

	de 0xc8 	; "N"
	de 0x92		; "5"
	de 0xc0		; "0"
	de 0xff 	; " "
	de 0xb0		; "3"
	de 0x19		; "4."
	de 0xa4		; "2"
	de 0x80		; "8"
	de 0x80		; "8"
	de 0xff 	; " "
	de 0x86		; "E"
	de 0xc0		; "0"
	de 0xc0		; "0"
	de 0x80		; "8"
	de 0xff 	; " "
	de 0xb0		; "3"
	de 0x24		; "2."
	de 0xc0		; "0"
	de 0xf9		; "1"
	de 0x92		; "5"
EEENDE
	end
